﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// 폴더
    /// </summary>
    public partial class Folder : ContentControl
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Event
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 확장 여부 변경시 - IsExpandedChanged

        /// <summary>
        /// 확장 여부 변경시
        /// </summary>
        public event EventHandler IsExpandedChanged;

        #endregion
        #region Expand 버튼 클릭시 - ExpandButtonClick

        /// <summary>
        /// Expand 버튼 클릭시
        /// </summary>
        public event EventHandler ExpandButtonClick;

        #endregion
        #region Close 버튼 클릭시 - CloseButtonClick

        /// <summary>
        /// Close 버튼 클릭시
        /// </summary>
        public event EventHandler CloseButtonClick;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 패널 테두리 의존 속성
        /// </summary>
        public static readonly DependencyProperty PanelBorderProperty;

        /// <summary>
        /// 자동 높이 의존 속성
        /// </summary>
        public static readonly DependencyProperty AutoHeightProperty;

        /// <summary>
        /// 헤더 높이 의존 속성
        /// </summary>
        public static readonly DependencyProperty HeaderHeightProperty;

        /// <summary>
        /// 헤더 배경색 의존 속성
        /// </summary>
        public static readonly DependencyProperty HeaderBackgroundProperty;

        /// <summary>
        /// 헤더 전경색 의존 속성
        /// </summary>
        public static readonly DependencyProperty HeaderForegroundProperty;

        /// <summary>
        /// 헤더 버튼 레귤러 의존 속성
        /// </summary>
        public static readonly DependencyProperty HeaderButtonRegularProperty;

        /// <summary>
        /// 헤더 버튼 호버 의존 속성
        /// </summary>
        public static readonly DependencyProperty HeaderButtonHoverProperty;

        /// <summary>
        /// 버튼 프레스 의존 속성
        /// </summary>
        public static readonly DependencyProperty HeaderButtonPressProperty;

        /// <summary>
        /// 헤더 텍스트 의존 속성
        /// </summary>
        public static readonly DependencyProperty HeaderTextProperty;

        /// <summary>
        /// 확장 여부 의존 속성
        /// </summary>
        public static readonly DependencyProperty IsExpandedProperty;

        /// <summary>
        /// Expand 버튼 표시 여부 의존 속성
        /// </summary>
        public static readonly DependencyProperty ExpandButtonVisibilityProperty;

        /// <summary>
        /// Close 버튼 표시 여부 의존 속성
        /// </summary>
        public static readonly DependencyProperty CloseButtonVisibilityProperty;

        /// <summary>
        /// 버튼 너비 의존 속성
        /// </summary>
        public static readonly DependencyProperty ButtonWidthProperty;

        /// <summary>
        /// 버튼 높이 의존 속성
        /// </summary>
        public static readonly DependencyProperty ButtonHeightProperty;

        #endregion
        
        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 원본 높이
        /// </summary>
        private double originalHeight = 0;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 패널 테두리 - PanelBorder

        /// <summary>
        /// 패널 테두리
        /// </summary>
        public Brush PanelBorder
        {
            get
            {
                return (Brush)GetValue(PanelBorderProperty);
            }
            set
            {
                SetValue(PanelBorderProperty, value);
            }
        }

        #endregion
        #region 자동 높이 - AutoHeight

        /// <summary>
        /// 자동 높이
        /// </summary>
        public bool AutoHeight
        {
            get
            {
                return (bool)GetValue(AutoHeightProperty);
            }
            set
            {
                SetValue(AutoHeightProperty, value);
            }
        }

        #endregion
        #region 헤더 높이 - HeaderHeight

        /// <summary>
        /// 헤더 높이
        /// </summary>
        public double HeaderHeight
        {
            get
            {
                return (double)GetValue(HeaderHeightProperty);
            }
            set
            {
                SetValue(HeaderHeightProperty, value);
            }
        }

        #endregion
        #region 헤더 배경색 - HeaderBackground

        /// <summary>
        /// 헤더 배경색
        /// </summary>
        public Brush HeaderBackground
        {
            get
            {
                return (Brush)GetValue(HeaderBackgroundProperty);
            }
            set
            {
                SetValue(HeaderBackgroundProperty, value);
            }
        }

        #endregion
        #region 헤더 전경색 - HeaderForeground

        /// <summary>
        /// 헤더 전경색
        /// </summary>
        public Brush HeaderForeground
        {
            get
            {
                return (Brush)GetValue(HeaderForegroundProperty);
            }
            set
            {
                SetValue(HeaderForegroundProperty, value);
            }
        }

        #endregion
        #region 헤더 버튼 레귤러 - HeaderButtonRegular

        /// <summary>
        /// 헤더 버튼 레귤러
        /// </summary>
        public Brush HeaderButtonRegular
        {
            get
            {
                return (Brush)GetValue(HeaderButtonRegularProperty);
            }
            set
            {
                SetValue(HeaderButtonRegularProperty, value);
            }
        }

        #endregion
        #region 헤더 버튼 호버 - HeaderButtonHover

        /// <summary>
        /// 헤더 버튼 호버
        /// </summary>
        public Brush HeaderButtonHover
        {
            get
            {
                return (Brush)GetValue(HeaderButtonHoverProperty);
            }
            set
            {
                SetValue(HeaderButtonHoverProperty, value);
            }
        }

        #endregion
        #region 헤더 버튼 프레스 - HeaderButtonPress

        /// <summary>
        /// 헤더 버튼 프레스
        /// </summary>
        public Brush HeaderButtonPress
        {
            get
            {
                return (Brush)GetValue(HeaderButtonPressProperty);
            }
            set
            {
                SetValue(HeaderButtonPressProperty, value);
            }
        }

        #endregion
        #region 헤더 텍스트 - HeaderText

        /// <summary>
        /// 헤더 텍스트
        /// </summary>
        public string HeaderText
        {
            get
            {
                return (string)GetValue(HeaderTextProperty);
            }
            set
            {
                SetValue(HeaderTextProperty, value);
            }
        }

        #endregion
        #region 확장 여부 - IsExpanded

        /// <summary>
        /// 확장 여부
        /// </summary>
        public bool IsExpanded
        {
            get
            {
                return (bool)GetValue(IsExpandedProperty);
            }
            set
            {
                SetValue(IsExpandedProperty, value);
            }
        }

        #endregion
        #region Expand 버튼 표시 여부 - ExpandButtonVisibility

        /// <summary>
        /// Expand 버튼 표시 여부
        /// </summary>
        public Visibility ExpandButtonVisibility
        {
            get
            {
                return (Visibility)GetValue(ExpandButtonVisibilityProperty);
            }
            set
            {
                SetValue(ExpandButtonVisibilityProperty, value);
            }
        }

        #endregion
        #region Close 버튼 표시 여부 - CloseButtonVisibility

        /// <summary>
        /// Close 버튼 표시 여부
        /// </summary>
        public Visibility CloseButtonVisibility
        {
            get
            {
                return (Visibility)GetValue(CloseButtonVisibilityProperty);
            }
            set
            {
                SetValue(CloseButtonVisibilityProperty, value);
            }
        }

        #endregion
        #region 버튼 너비 - ButtonWidth

        /// <summary>
        /// 버튼 너비
        /// </summary>
        public double ButtonWidth
        {
            get
            {
                return (double)GetValue(ButtonWidthProperty);
            }
            set
            {
                SetValue(ButtonWidthProperty, value);
            }
        }

        #endregion
        #region 버튼 높이 - ButtonHeight

        /// <summary>
        /// 버튼 높이
        /// </summary>
        public double ButtonHeight
        {
            get
            {
                return (double)GetValue(ButtonHeightProperty);
            }
            set
            {
                SetValue(ButtonHeightProperty, value);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Static

        #region 생성자 - Folder()

        /// <summary>
        /// 생성자
        /// </summary>
        static Folder()
        {
            PanelBorderProperty            = UIHelper.RegisterDependencyProperty(Brushes.RoyalBlue , false, false, false, true, null                             , "PanelBorder"           , typeof(Brush)     , typeof(Folder), null);
            AutoHeightProperty             = UIHelper.RegisterDependencyProperty(false             , false, false, false, true, null                             , "AutoHeight"            , typeof(bool)      , typeof(Folder), null);
            HeaderHeightProperty           = UIHelper.RegisterDependencyProperty(26d               , false, false, false, true, null                             , "HeaderHeight"          , typeof(double)    , typeof(Folder), null);
            HeaderForegroundProperty       = UIHelper.RegisterDependencyProperty(Brushes.White     , false, false, false, true, null                             , "HeaderForeground"      , typeof(Brush)     , typeof(Folder), null);
            HeaderBackgroundProperty       = UIHelper.RegisterDependencyProperty(Brushes.RoyalBlue , false, false, false, true, null                             , "HeaderBackground"      , typeof(Brush)     , typeof(Folder), null);
            HeaderButtonRegularProperty    = UIHelper.RegisterDependencyProperty(Brushes.White     , false, false, false, true, null                             , "HeaderButtonRegular"   , typeof(Brush)     , typeof(Folder), null);
            HeaderButtonHoverProperty      = UIHelper.RegisterDependencyProperty(Brushes.Yellow    , false, false, false, true, null                             , "HeaderButtonHover"     , typeof(Brush)     , typeof(Folder), null);
            HeaderButtonPressProperty      = UIHelper.RegisterDependencyProperty(Brushes.Gold      , false, false, false, true, null                             , "HeaderButtonPress"     , typeof(Brush)     , typeof(Folder), null);
            HeaderTextProperty             = UIHelper.RegisterDependencyProperty(string.Empty      , false, false, false, true, null                             , "HeaderText"            , typeof(string)    , typeof(Folder), null);
            IsExpandedProperty             = UIHelper.RegisterDependencyProperty(true              , false, false, false, true, isExpandedPropertyChangedCallback, "IsExpanded"            , typeof(bool)      , typeof(Folder), null);
            ExpandButtonVisibilityProperty = UIHelper.RegisterDependencyProperty(Visibility.Visible, false, false, false, true, null                             , "ExpandButtonVisibility", typeof(Visibility), typeof(Folder), null);
            CloseButtonVisibilityProperty  = UIHelper.RegisterDependencyProperty(Visibility.Visible, false, false, false, true, null                             , "CloseButtonVisibility" , typeof(Visibility), typeof(Folder), null);
            ButtonWidthProperty            = UIHelper.RegisterDependencyProperty(20d               , false, false, false, true, null                             , "ButtonWidth"           , typeof(double)    , typeof(Folder), null);
            ButtonHeightProperty           = UIHelper.RegisterDependencyProperty(20d               , false, false, false, true, null                             , "ButtonHeight"          , typeof(double)    , typeof(Folder), null);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - Folder()

        /// <summary>
        /// 생성자
        /// </summary>
        public Folder()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 확장 여부 속성 변경시 콜백 처리하기 - isExpandedPropertyChangedCallback(dependencyObject, e)

        /// <summary>
        /// 확장 여부 속성 변경시 콜백 처리하기
        /// </summary>
        /// <param name="dependencyObject">의존 객체</param>
        /// <param name="e">이벤트 인자</param>
        private static void isExpandedPropertyChangedCallback(DependencyObject dependencyObject, DependencyPropertyChangedEventArgs e)
        {
            Folder expanderPanel = dependencyObject as Folder;


            bool newValue = (bool)e.NewValue;

            if(expanderPanel.AutoHeight)
            {
                if(newValue)
                {
                    expanderPanel.Height = expanderPanel.originalHeight;
                }
                else
                {
                    expanderPanel.originalHeight = expanderPanel.ActualHeight;

                    expanderPanel.Height = expanderPanel.HeaderHeight + 2;
                }
            }


            expanderPanel.FireIsExpandedChanged();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Protected

        #region 확장 여부 변경시 이벤트 발생시키기 - FireIsExpandedChanged()

        /// <summary>
        /// 확장 여부 변경시 이벤트 발생시키기
        /// </summary>
        protected void FireIsExpandedChanged()
        {
            if(IsExpandedChanged != null)
            {
                IsExpandedChanged(this, EventArgs.Empty);
            }
        }

        #endregion
        #region Expand 버튼 클릭시 이벤트 발생시키기 - FireExpandButtonClick()

        /// <summary>
        /// Expand 버튼 클릭시 이벤트 발생시키기
        /// </summary>
        protected void FireExpandButtonClick()
        {
            if(ExpandButtonClick != null)
            {
                ExpandButtonClick(this, EventArgs.Empty);
            }
        }

        #endregion
        #region Close 버튼 클릭시 이벤트 발생시키기 - FireCloseButtonClick()

        /// <summary>
        /// Close 버튼 클릭시 이벤트 발생시키기
        /// </summary>
        protected void FireCloseButtonClick()
        {
            if(CloseButtonClick != null)
            {
                CloseButtonClick(this, EventArgs.Empty);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region Expand 버튼 클릭시 처리하기 - expandButton_Click(sender, e)

        /// <summary>
        /// Expand 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void expandButton_Click(object sender, RoutedEventArgs e)
        {
            IsExpanded = !IsExpanded;

            FireExpandButtonClick();
        }

        #endregion
        #region Close 버튼 클릭시 처리하기 - closeButton_Click(sender, e)

        /// <summary>
        /// Close 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void closeButton_Click(object sender, RoutedEventArgs e)
        {
            FireCloseButtonClick();
        }

        #endregion
    }
}