﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// 모노 버튼
    /// </summary>
    public partial class MonoButton : Button
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 모노 타입 의존 속성
        /// </summary>
        public static readonly DependencyProperty MonoTypeProperty;

        /// <summary>
        /// 레귤러 의존 속성
        /// </summary>
        public static readonly DependencyProperty RegularProperty;

        /// <summary>
        /// 호버 의존 속성
        /// </summary>
        public static readonly DependencyProperty HoverProperty;

        /// <summary>
        /// 프레스 의존 속성
        /// </summary>
        public static readonly DependencyProperty PressProperty;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 모노 타입 - MonoType

        /// <summary>
        /// 모노 타입
        /// </summary>
        public MonoType MonoType
        {
            get
            {
                return (MonoType)GetValue(MonoTypeProperty);
            }
            set
            {
                SetValue(MonoTypeProperty, value);
            }
        }

        #endregion
        #region 레귤러 - Regular

        /// <summary>
        /// 레귤러
        /// </summary>
        public Brush Regular
        {
            get
            {
                return (Brush)GetValue(RegularProperty);
            }
            set
            {
                SetValue(RegularProperty, value);
            }
        }

        #endregion
        #region 호버 - Hover

        /// <summary>
        /// 호버
        /// </summary>
        public Brush Hover
        {
            get
            {
                return (Brush)GetValue(HoverProperty);
            }
            set
            {
                SetValue(HoverProperty, value);
            }
        }

        #endregion
        #region 프레스 - Press

        /// <summary>
        /// 프레스
        /// </summary>
        public Brush Press
        {
            get
            {
                return (Brush)GetValue(PressProperty);
            }
            set
            {
                SetValue(PressProperty, value);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Static

        #region 생성자 - MonoButton()

        /// <summary>
        /// 생성자
        /// </summary>
        static MonoButton()
        {
            MonoTypeProperty = UIHelper.RegisterDependencyProperty(MonoType.None , false, false, false, true, null, "MonoType", typeof(MonoType), typeof(MonoButton), null);
            RegularProperty  = UIHelper.RegisterDependencyProperty(Brushes.White , false, false, false, true, null, "Regular" , typeof(Brush)   , typeof(MonoButton), null);
            HoverProperty    = UIHelper.RegisterDependencyProperty(Brushes.Yellow, false, false, false, true, null, "Hover"   , typeof(Brush)   , typeof(MonoButton), null);
            PressProperty    = UIHelper.RegisterDependencyProperty(Brushes.Gold  , false, false, false, true, null, "Press"   , typeof(Brush)   , typeof(MonoButton), null);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MonoButton()

        /// <summary>
        /// 생성자
        /// </summary>
        public MonoButton()
        {
            InitializeComponent();
        }

        #endregion
    }
}