﻿using System;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.singleListBox.ValueChanged       += singleListBox_ValueChanged;
            this.singleComboBox.ValueChanged      += singleComboBox_ValueChanged;
            this.multiListBox.ValuesChanged       += multiListBox_ValuesChanged;
            this.multiComboBox.ValuesChanged      += multiComboBox_ValuesChanged;
            this.priorityListBox.ValuesChanged    += priorityListBox_ValuesChanged;
            this.priorityComboBox.ValuesChanged   += priorityComboBox_ValuesChanged;
            this.folder.IsExpandedChanged         += folder_IsExpandedChanged;
            this.folder.CloseButtonClick          += folder_CloseButtonClick;
            this.iconPopupButton.ValueChanged     += iconPopupButton_ValueChanged;
            this.iconSelectorButton1.Click        += iconSelectorButton_Click;
            this.iconSelectorButton2.Click        += iconSelectorButton_Click;
            this.iconSelectorButton3.Click        += iconSelectorButton_Click;
            this.iconSelectorButton4.Click        += iconSelectorButton_Click;
            this.iconSelectorButton1.ValueChanged += iconSelectorButton_ValueChanged;
            this.iconSelectorButton2.ValueChanged += iconSelectorButton_ValueChanged;
            this.iconSelectorButton3.ValueChanged += iconSelectorButton_ValueChanged;
            this.iconSelectorButton4.ValueChanged += iconSelectorButton_ValueChanged;
            this.fontDialogButton.Click           += fontDialogButton_Click;
            this.layoutButton.CountChanged        += layoutButton_CountChanged;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region SingleListBox 값 변경시 처리하기 - singleListBox_ValueChanged(sender, e)

        /// <summary>
        /// SingleListBox 값 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void singleListBox_ValueChanged(object sender, EventArgs e)
        {
            this.singleListBoxTextBlock.Text = this.singleListBox.Value;
        }

        #endregion
        #region SingleListBox Data 버튼 클릭시 처리하기 - singleListBoxDataButton_Click(sender, e)

        /// <summary>
        /// SingleListBox Data 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void singleListBoxDataButton_Click(object sender, RoutedEventArgs e)
        {
            BitmapImage bitmapImage01 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/보고서.png"    ));
            BitmapImage bitmapImage02 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/사이트보기.png"));
            BitmapImage bitmapImage03 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/순번.png"      ));
            BitmapImage bitmapImage04 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/얼굴.png"      ));
            BitmapImage bitmapImage05 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/일괄수정.png"  ));
            BitmapImage bitmapImage06 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/저장소.png"    ));
            BitmapImage bitmapImage07 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/찾기.png"      ));
            BitmapImage bitmapImage08 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/처리완료.png"  ));
            BitmapImage bitmapImage09 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/파일.png"      ));
            BitmapImage bitmapImage10 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/파일보기.png"  ));

            ObservableCollection<ListItem> collection = new ObservableCollection<ListItem>();

            collection.Add(new ListItem(false, bitmapImage01, "A1", "A2"));
            collection.Add(new ListItem(false, bitmapImage02, "B1", "B2"));
            collection.Add(new ListItem(false, bitmapImage03, "C1", "C2"));
            collection.Add(new ListItem(false, bitmapImage04, "D1", "D2"));
            collection.Add(new ListItem(false, bitmapImage05, "E1", "E2"));
            collection.Add(new ListItem(false, bitmapImage06, "F1", "F2"));
            collection.Add(new ListItem(false, bitmapImage07, "G1", "G2"));
            collection.Add(new ListItem(false, bitmapImage08, "H1", "H2"));
            collection.Add(new ListItem(false, bitmapImage09, "I1", "I2"));
            collection.Add(new ListItem(false, bitmapImage10, "J1", "J2"));

            this.singleListBox.ItemsSource = collection;
        }

        #endregion
        #region SingleListBox Value 버튼 클릭시 처리하기 - singleListBoxValueButton_Click(sender, e)

        /// <summary>
        /// SingleListBox Value 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void singleListBoxValueButton_Click(object sender, RoutedEventArgs e)
        {
            this.singleListBox.Value = "F1";
        }

        #endregion

        #region SingleComboBox 값 변경시 처리하기 - singleComboBox_ValueChanged(sender, e)

        /// <summary>
        /// SingleComboBox 값 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void singleComboBox_ValueChanged(object sender, EventArgs e)
        {
            this.singleComboBoxTextBlock.Text = this.singleComboBox.Value;
        }

        #endregion
        #region SingleComboBox Data 버튼 클릭시 처리하기 - singleComboBoxDataButton_Click(sender, e)

        /// <summary>
        /// SingleComboBox Data 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void singleComboBoxDataButton_Click(object sender, RoutedEventArgs e)
        {
            BitmapImage bitmapImage01 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/보고서.png"    ));
            BitmapImage bitmapImage02 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/사이트보기.png"));
            BitmapImage bitmapImage03 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/순번.png"      ));
            BitmapImage bitmapImage04 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/얼굴.png"      ));
            BitmapImage bitmapImage05 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/일괄수정.png"  ));
            BitmapImage bitmapImage06 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/저장소.png"    ));
            BitmapImage bitmapImage07 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/찾기.png"      ));
            BitmapImage bitmapImage08 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/처리완료.png"  ));
            BitmapImage bitmapImage09 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/파일.png"      ));
            BitmapImage bitmapImage10 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/파일보기.png"  ));

            ObservableCollection<ListItem> collection = new ObservableCollection<ListItem>();

            collection.Add(new ListItem(false, bitmapImage01, "A1", "A2"));
            collection.Add(new ListItem(false, bitmapImage02, "B1", "B2"));
            collection.Add(new ListItem(false, bitmapImage03, "C1", "C2"));
            collection.Add(new ListItem(false, bitmapImage04, "D1", "D2"));
            collection.Add(new ListItem(false, bitmapImage05, "E1", "E2"));
            collection.Add(new ListItem(false, bitmapImage06, "F1", "F2"));
            collection.Add(new ListItem(false, bitmapImage07, "G1", "G2"));
            collection.Add(new ListItem(false, bitmapImage08, "H1", "H2"));
            collection.Add(new ListItem(false, bitmapImage09, "I1", "I2"));
            collection.Add(new ListItem(false, bitmapImage10, "J1", "J2"));

            this.singleComboBox.ItemsSource = collection;
        }

        #endregion
        #region SingleComboBox Value 버튼 클릭시 처리하기 - singleComboBoxValueButton_Click(sender, e)

        /// <summary>
        /// SingleComboBox Value 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void singleComboBoxValueButton_Click(object sender, RoutedEventArgs e)
        {
            this.singleComboBox.Value = "F1";
        }

        #endregion

        #region MultiListBox 값 목록 변경시 처리하기 - multiListBox_ValuesChanged(sender, e)

        /// <summary>
        /// MultiListBox 값 목록 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiListBox_ValuesChanged(object sender, EventArgs e)
        {
            this.multiListBoxTextBlock.Text = this.multiListBox.Values;
        }

        #endregion
        #region MultiListBox Data 버튼 클릭시 처리하기 - multiListBoxDataButton_Click(sender, e)

        /// <summary>
        /// MultiListBox Data 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiListBoxDataButton_Click(object sender, RoutedEventArgs e)
        {
            BitmapImage bitmapImage01 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/보고서.png"    ));
            BitmapImage bitmapImage02 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/사이트보기.png"));
            BitmapImage bitmapImage03 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/순번.png"      ));
            BitmapImage bitmapImage04 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/얼굴.png"      ));
            BitmapImage bitmapImage05 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/일괄수정.png"  ));
            BitmapImage bitmapImage06 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/저장소.png"    ));
            BitmapImage bitmapImage07 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/찾기.png"      ));
            BitmapImage bitmapImage08 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/처리완료.png"  ));
            BitmapImage bitmapImage09 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/파일.png"      ));
            BitmapImage bitmapImage10 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/파일보기.png"  ));

            ObservableCollection<ListItem> collection = new ObservableCollection<ListItem>();

            collection.Add(new ListItem(false, bitmapImage01, "A1", "A2"));
            collection.Add(new ListItem(false, bitmapImage02, "B1", "B2"));
            collection.Add(new ListItem(false, bitmapImage03, "C1", "C2"));
            collection.Add(new ListItem(false, bitmapImage04, "D1", "D2"));
            collection.Add(new ListItem(false, bitmapImage05, "E1", "E2"));
            collection.Add(new ListItem(false, bitmapImage06, "F1", "F2"));
            collection.Add(new ListItem(false, bitmapImage07, "G1", "G2"));
            collection.Add(new ListItem(false, bitmapImage08, "H1", "H2"));
            collection.Add(new ListItem(false, bitmapImage09, "I1", "I2"));
            collection.Add(new ListItem(false, bitmapImage10, "J1", "J2"));

            this.multiListBox.ItemsSource = collection;
        }

        #endregion
        #region MultiListBox Value 버튼 클릭시 처리하기 - multiListBoxValueButton_Click(sender, e)

        /// <summary>
        /// MultiListBox Value 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiListBoxValueButton_Click(object sender, RoutedEventArgs e)
        {
            this.multiListBox.Values = "H1,F1";
        }

        #endregion
        #region MultiListBox Check All 버튼 클릭시 처리하기 - multiListBoxCheckAllButton_Click(sender, e)

        /// <summary>
        /// MultiListBox Check All 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiListBoxCheckAllButton_Click(object sender, RoutedEventArgs e)
        {
            this.multiListBox.CheckAll();
        }

        #endregion
        #region MultiListBox Uncheck All 버튼 클릭시 처리하기 - multiListBoxUncheckAllButton_Click(sender, e)

        /// <summary>
        /// MultiListBox Uncheck All 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiListBoxUncheckAllButton_Click(object sender, RoutedEventArgs e)
        {
            this.multiListBox.UncheckAll();
        }

        #endregion
        #region MultiListBox Move TopMost 버튼 클릭시 처리하기 - multiListBoxMoveTopMostButton_Click(sender, e)

        /// <summary>
        /// MultiListBox Move TopMost 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiListBoxMoveTopMostButton_Click(object sender, RoutedEventArgs e)
        {
            this.multiListBox.MoveTopMost();
        }

        #endregion
        #region MultiListBox Move Top 버튼 클릭시 처리하기 - multiListBoxMoveTopButton_Click(sender, e)

        /// <summary>
        /// MultiListBox Move Top 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiListBoxMoveTopButton_Click(object sender, RoutedEventArgs e)
        {
            this.multiListBox.MoveTop();
        }

        #endregion
        #region MultiListBox Move Bottom 버튼 클릭시 처리하기 - multiListBoxMoveBottomButton_Click(sender, e)

        /// <summary>
        /// MultiListBox Move Bottom 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiListBoxMoveBottomButton_Click(object sender, RoutedEventArgs e)
        {
            this.multiListBox.MoveBottom();
        }

        #endregion

        #region MultiComboBox 값 목록 변경시 처리하기 - multiComboBox_ValuesChanged(sender, e)

        /// <summary>
        /// MultiComboBox 값 목록 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiComboBox_ValuesChanged(object sender, EventArgs e)
        {
            this.multiComboBoxTextBlock.Text = this.multiComboBox.Values;
        }

        #endregion
        #region MultiComboBox Data 버튼 클릭시 처리하기 - multiComboBoxDataButton_Click(sender, e)

        /// <summary>
        /// MultiComboBox Data 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiComboBoxDataButton_Click(object sender, RoutedEventArgs e)
        {
            BitmapImage bitmapImage01 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/보고서.png"    ));
            BitmapImage bitmapImage02 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/사이트보기.png"));
            BitmapImage bitmapImage03 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/순번.png"      ));
            BitmapImage bitmapImage04 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/얼굴.png"      ));
            BitmapImage bitmapImage05 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/일괄수정.png"  ));
            BitmapImage bitmapImage06 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/저장소.png"    ));
            BitmapImage bitmapImage07 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/찾기.png"      ));
            BitmapImage bitmapImage08 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/처리완료.png"  ));
            BitmapImage bitmapImage09 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/파일.png"      ));
            BitmapImage bitmapImage10 = new BitmapImage(ResourceHelper.GetResourceUri(null, "Image/파일보기.png"  ));

            ObservableCollection<ListItem> collection = new ObservableCollection<ListItem>();

            collection.Add(new ListItem(false, bitmapImage01, "A1", "A2"));
            collection.Add(new ListItem(false, bitmapImage02, "B1", "B2"));
            collection.Add(new ListItem(false, bitmapImage03, "C1", "C2"));
            collection.Add(new ListItem(false, bitmapImage04, "D1", "D2"));
            collection.Add(new ListItem(false, bitmapImage05, "E1", "E2"));
            collection.Add(new ListItem(false, bitmapImage06, "F1", "F2"));
            collection.Add(new ListItem(false, bitmapImage07, "G1", "G2"));
            collection.Add(new ListItem(false, bitmapImage08, "H1", "H2"));
            collection.Add(new ListItem(false, bitmapImage09, "I1", "I2"));
            collection.Add(new ListItem(false, bitmapImage10, "J1", "J2"));

            this.multiComboBox.ItemsSource = collection;
        }

        #endregion
        #region MultiComboBox Value 버튼 클릭시 처리하기 - multiComboBoxValueButton_Click(sender, e)

        /// <summary>
        /// MultiComboBox Value 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiComboBoxValueButton_Click(object sender, RoutedEventArgs e)
        {
            this.multiComboBox.Values = "H1,F1";
        }

        #endregion
        #region MultiComboBox Check All 버튼 클릭시 처리하기 - multiComboBoxCheckAllButton_Click(sender, e)

        /// <summary>
        /// MultiComboBox Check All 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiComboBoxCheckAllButton_Click(object sender, RoutedEventArgs e)
        {
            this.multiComboBox.CheckAll();
        }

        #endregion
        #region MultiComboBox Uncheck All 버튼 클릭시 처리하기 - multiComboBoxUncheckAllButton_Click(sender, e)

        /// <summary>
        /// MultiComboBox Uncheck All 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiComboBoxUncheckAllButton_Click(object sender, RoutedEventArgs e)
        {
            this.multiComboBox.UncheckAll();
        }

        #endregion
        #region MultiComboBox Move TopMost 버튼 클릭시 처리하기 - multiComboBoxMoveTopMostButton_Click(sender, e)

        /// <summary>
        /// MultiComboBox Move TopMost 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiComboBoxMoveTopMostButton_Click(object sender, RoutedEventArgs e)
        {
            this.multiComboBox.MoveTopMost();
        }

        #endregion
        #region MultiComboBox Move Top 버튼 클릭시 처리하기 - multiComboBoxMoveTopButton_Click(sender, e)

        /// <summary>
        /// MultiComboBox Move Top 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiComboBoxMoveTopButton_Click(object sender, RoutedEventArgs e)
        {
            this.multiComboBox.MoveTop();
        }

        #endregion
        #region MultiComboBox Move Bottom 버튼 클릭시 처리하기 - multiComboBoxMoveBottomButton_Click(sender, e)

        /// <summary>
        /// MultiComboBox Move Bottom 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void multiComboBoxMoveBottomButton_Click(object sender, RoutedEventArgs e)
        {
            this.multiComboBox.MoveBottom();
        }

        #endregion

        #region PriorityListBox 값 목록 변경시 처리하기 - priorityListBox_ValuesChanged(sender, e)

        /// <summary>
        /// PriorityListBox 값 목록 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityListBox_ValuesChanged(object sender, EventArgs e)
        {
            this.priorityListBoxTextBlock.Text = this.priorityListBox.Values;
        }

        #endregion
        #region PriorityListBox Data 버튼 클릭시 처리하기 - priorityListBoxDataButton_Click(sender, e)

        /// <summary>
        /// PriorityListBox Data 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityListBoxDataButton_Click(object sender, RoutedEventArgs e)
        {
            ObservableCollection<PriorityItem> collection = new ObservableCollection<PriorityItem>();

            collection.Add(new PriorityItem(false, "A1", "A2"));
            collection.Add(new PriorityItem(false, "B1", "B2"));
            collection.Add(new PriorityItem(false, "C1", "C2"));
            collection.Add(new PriorityItem(false, "D1", "D2"));
            collection.Add(new PriorityItem(false, "E1", "E2"));
            collection.Add(new PriorityItem(false, "F1", "F2"));
            collection.Add(new PriorityItem(false, "G1", "G2"));
            collection.Add(new PriorityItem(false, "H1", "H2"));
            collection.Add(new PriorityItem(false, "I1", "I2"));
            collection.Add(new PriorityItem(false, "J1", "J2"));

            this.priorityListBox.ItemsSource = collection;
        }

        #endregion
        #region PriorityListBox Value 버튼 클릭시 처리하기 - priorityListBoxValueButton_Click(sender, e)

        /// <summary>
        /// PriorityListBox Value 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityListBoxValueButton_Click(object sender, RoutedEventArgs e)
        {
            this.priorityListBox.Values = "H1 DESC,F1 DESC";
        }

        #endregion
        #region PriorityListBox Check All 버튼 클릭시 처리하기 - priorityListBoxCheckAllButton_Click(sender, e)

        /// <summary>
        /// PriorityListBox Check All 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityListBoxCheckAllButton_Click(object sender, RoutedEventArgs e)
        {
            this.priorityListBox.CheckAll();
        }

        #endregion
        #region PriorityListBox Uncheck All 버튼 클릭시 처리하기 - priorityListBoxUncheckAllButton_Click(sender, e)

        /// <summary>
        /// PriorityListBox Uncheck All 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityListBoxUncheckAllButton_Click(object sender, RoutedEventArgs e)
        {
            this.priorityListBox.UncheckAll();
        }

        #endregion
        #region PriorityListBox Move TopMost 버튼 클릭시 처리하기 - priorityListBoxMoveTopMostButton_Click(sender, e)

        /// <summary>
        /// PriorityListBox Move TopMost 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityListBoxMoveTopMostButton_Click(object sender, RoutedEventArgs e)
        {
            this.priorityListBox.MoveTopMost();
        }

        #endregion
        #region PriorityListBox Move Top 버튼 클릭시 처리하기 - priorityListBoxMoveTopButton_Click(sender, e)

        /// <summary>
        /// PriorityListBox Move Top 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityListBoxMoveTopButton_Click(object sender, RoutedEventArgs e)
        {
            this.priorityListBox.MoveTop();
        }

        #endregion
        #region PriorityListBox Move Bottom 버튼 클릭시 처리하기 - priorityListBoxMoveBottomButton_Click(sender, e)

        /// <summary>
        /// PriorityListBox Move Bottom 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityListBoxMoveBottomButton_Click(object sender, RoutedEventArgs e)
        {
            this.priorityListBox.MoveBottom();
        }

        #endregion
        #region PriorityListBox Show Priority 버튼 클릭시 처리하기 - priorityListBoxShowPriorityButton_Click(sender, e)

        /// <summary>
        /// PriorityListBox Show Priority 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityListBoxShowPriorityButton_Click(object sender, RoutedEventArgs e)
        {
            this.priorityListBox.ShowPriority = !this.priorityListBox.ShowPriority;
        }

        #endregion

        #region PriorityComboBox 값 목록 변경시 처리하기 - columnComboBox_ValuesChanged(sender, e)

        /// <summary>
        /// PriorityComboBox 값 목록 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityComboBox_ValuesChanged(object sender, EventArgs e)
        {
            this.priorityComboBoxTextBlock.Text = this.priorityComboBox.Values;
        }

        #endregion
        #region PriorityComboBox Data 버튼 클릭시 처리하기 - priorityComboBoxDataButton_Click(sender, e)

        /// <summary>
        /// PriorityComboBox Data 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityComboBoxDataButton_Click(object sender, RoutedEventArgs e)
        {
            ObservableCollection<PriorityItem> collection = new ObservableCollection<PriorityItem>();

            collection.Add(new PriorityItem(false, "A1", "A2"));
            collection.Add(new PriorityItem(false, "B1", "B2"));
            collection.Add(new PriorityItem(false, "C1", "C2"));
            collection.Add(new PriorityItem(false, "D1", "D2"));
            collection.Add(new PriorityItem(false, "E1", "E2"));
            collection.Add(new PriorityItem(false, "F1", "F2"));
            collection.Add(new PriorityItem(false, "G1", "G2"));
            collection.Add(new PriorityItem(false, "H1", "H2"));
            collection.Add(new PriorityItem(false, "I1", "I2"));
            collection.Add(new PriorityItem(false, "J1", "J2"));

            this.priorityComboBox.ItemsSource = collection;
        }

        #endregion
        #region PriorityComboBox Value 버튼 클릭시 처리하기 - priorityComboBoxValueButton_Click(sender, e)

        /// <summary>
        /// PriorityComboBox Value 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityComboBoxValueButton_Click(object sender, RoutedEventArgs e)
        {
            this.priorityComboBox.Values = "H1 DESC,F1 DESC";
        }

        #endregion
        #region PriorityComboBox Check All 버튼 클릭시 처리하기 - priorityComboBoxCheckAllButton_Click(sender, e)

        /// <summary>
        /// PriorityComboBox Check All 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityComboBoxCheckAllButton_Click(object sender, RoutedEventArgs e)
        {
            this.priorityComboBox.CheckAll();
        }

        #endregion
        #region PriorityComboBox Uncheck All 버튼 클릭시 처리하기 - priorityComboBoxUncheckAllButton_Click(sender, e)

        /// <summary>
        /// PriorityComboBox Uncheck All 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityComboBoxUncheckAllButton_Click(object sender, RoutedEventArgs e)
        {
            this.priorityComboBox.UncheckAll();
        }

        #endregion
        #region PriorityComboBox Move TopMost 버튼 클릭시 처리하기 - priorityComboBoxMoveTopMostButton_Click(sender, e)

        /// <summary>
        /// PriorityComboBox Move TopMost 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityComboBoxMoveTopMostButton_Click(object sender, RoutedEventArgs e)
        {
            this.priorityComboBox.MoveTopMost();
        }

        #endregion
        #region PriorityComboBox Move Top 버튼 클릭시 처리하기 - priorityComboBoxMoveTopButton_Click(sender, e)

        /// <summary>
        /// PriorityComboBox Move Top 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityComboBoxMoveTopButton_Click(object sender, RoutedEventArgs e)
        {
            this.priorityComboBox.MoveTop();
        }

        #endregion
        #region PriorityComboBox Move Bottom 버튼 클릭시 처리하기 - priorityComboBoxMoveBottomButton_Click(sender, e)

        /// <summary>
        /// PriorityComboBox Move Bottom 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityComboBoxMoveBottomButton_Click(object sender, RoutedEventArgs e)
        {
            this.priorityComboBox.MoveBottom();
        }

        #endregion
        #region PriorityComboBox Show Priority 버튼 클릭시 처리하기 - priorityComboBoxShowPriorityButton_Click(sender, e)

        /// <summary>
        /// PriorityComboBox Show Priority 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void priorityComboBoxShowPriorityButton_Click(object sender, RoutedEventArgs e)
        {
            this.priorityComboBox.ShowPriority = !this.priorityComboBox.ShowPriority;
        }

        #endregion

        #region Folder 확장 여부 변경시 처리하기 - folder_IsExpandedChanged(sender, e)

        /// <summary>
        /// Folder 확장 여부 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void folder_IsExpandedChanged(object sender, EventArgs e)
        {
            this.folderTextBlock.Text = this.folder.IsExpanded == true ? "Expanded" : "Collapsed";
        }

        #endregion
        #region Folder Close 버튼 클릭시 처리하기 - folder_CloseButtonClick(sender, e)

        /// <summary>
        /// Folder Close 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void folder_CloseButtonClick(object sender, EventArgs e)
        {
            this.folderTextBlock.Text = "Close button clicked.";
        }

        #endregion

        #region IconPopupButton 값 변경시 처리하기 - iconPopupButton_ValueChanged(sender, e)

        /// <summary>
        /// IconPopupButton 값 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void iconPopupButton_ValueChanged(object sender, EventArgs e)
        {
            this.iconPopupButtonTextBlock.Text = this.iconPopupButton.Value;
        }

        #endregion

        #region IconSelectorButton 클릭시 처리하기 - iconSelectorButton_Click(sender, e)

        /// <summary>
        /// IconSelectorButton 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void iconSelectorButton_Click(object sender, EventArgs e)
        {
            IconSelectorButton sourceButton = sender as IconSelectorButton;

            UncheckIconSelectorButtonsInSameGroup(sourceButton);

            this.iconSelectorButtonTextBlock.Text = sourceButton.Value + "으로 변경되었습니다.";
        }

        #endregion
        #region IconSelectorButton 값 변경시 처리하기 - iconSelectorButton_ValueChanged(sender, e)

        /// <summary>
        /// IconSelectorButton 값 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void iconSelectorButton_ValueChanged(object sender, EventArgs e)
        {
            IconSelectorButton sourceButton = sender as IconSelectorButton;

            if(sourceButton.IsChecked.GetValueOrDefault())
            {
            }
            else
            {
                sourceButton.IsChecked = true;

                UncheckIconSelectorButtonsInSameGroup(sourceButton);
            }

            this.iconSelectorButtonTextBlock.Text = sourceButton.Value + "으로 변경되었습니다.";
        }

        #endregion

        #region FontDialog 버튼 클릭시 처리하기 - fontDialogButton_Click(sender, e)

        /// <summary>
        /// FontDialog 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void fontDialogButton_Click(object sender, RoutedEventArgs e)
        {
            Typeface typeface = new Typeface
            (
                this.fontDialogButton.FontFamily,
                this.fontDialogButton.FontStyle,
                this.fontDialogButton.FontWeight,
                this.fontDialogButton.FontStretch
            );

            double faceSize = this.fontDialogButton.FontSize;

            FontDialog fontDialog = new FontDialog();

            fontDialog.Typeface = typeface;
            fontDialog.FaceSize = faceSize;

            if(fontDialog.ShowDialog().GetValueOrDefault())
            {
                this.fontDialogButton.FontFamily  = fontDialog.Typeface.FontFamily;
                this.fontDialogButton.FontStyle   = fontDialog.Typeface.Style;
                this.fontDialogButton.FontWeight  = fontDialog.Typeface.Weight;
                this.fontDialogButton.FontStretch = fontDialog.Typeface.Stretch;
                this.fontDialogButton.FontSize    = fontDialog.FaceSize;
            }
        }

        #endregion

        #region LayoutButton 카운트 변경시 처리하기 - layoutButton_CountChanged(sender, e)

        /// <summary>
        /// LayoutButton 카운트 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void layoutButton_CountChanged(object sender, EventArgs e)
        {
            this.layoutButtonTextBlock.Text = string.Format("{0}행 × {1}열이 선택되었습니다.", this.layoutButton.RowCount, this.layoutButton.ColumnCount);
        }

        #endregion 

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 동일 그룹 아이콘 셀렉터 버튼 체크 취소하기 - UncheckIconSelectorButtonsInSameGroup(sourceButton)

        /// <summary>
        /// 동일 그룹 아이콘 셀렉터 버튼 체크 취소하기
        /// </summary>
        /// <param name="sourceButton">소스 버튼</param>
        private void UncheckIconSelectorButtonsInSameGroup(IconSelectorButton sourceButton)
        {
            foreach(UIElement uiElement in this.stackPanel.Children)
            {
                if(uiElement is IconSelectorButton)
                {
                    IconSelectorButton button = uiElement as IconSelectorButton;

                    if(button == sourceButton)
                    {
                        continue;
                    }
                    else
                    {
                        if(button.GroupName == sourceButton.GroupName)
                        {
                            button.IsChecked = false;
                        }
                    }
                }
            }
        }

        #endregion
    }
}