﻿using System;
using System.IO;
using System.Windows;

namespace TestProject
{
    /// <summary>
    /// 리소스 헬퍼
    /// </summary>
    public class ResourceHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 리소스 URI 구하기 - GetResourceUri(assemblyName, resourcePath)

        /// <summary>
        /// 리소스 URI 구하기
        /// </summary>
        /// <param name="assemblyName">어셈블리명</param>
        /// <param name="resourcePath">리소스 경로</param>
        /// <returns>리소스 URI</returns>
        public static Uri GetResourceUri(string assemblyName, string resourcePath)
        {
            if(string.IsNullOrEmpty(assemblyName))
            {
                return new Uri(string.Format("pack://application:,,,/{0}", resourcePath));
            }
            else
            {
                return new Uri(string.Format("pack://application:,,,/{0};component/{1}", assemblyName, resourcePath));
            }
        }

        #endregion
        #region 리소스 스트림 구하기 - GetResourceStream(resourceUri)

        /// <summary>
        /// 리소스 스트림 구하기
        /// </summary>
        /// <param name="resourceUri">리소스 URI</param>
        /// <returns>리소스 스트림</returns>
        public static Stream GetResourceStream(Uri resourceUri)
        {
            return Application.GetResourceStream(resourceUri).Stream;
        }

        #endregion
    }
}